;................................................
.686 ; create 32 bit code
;The MASM32 Runtime Library include file.
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Include   \masm32\include\masm32rt.inc
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Include   \masm32\fpulib\fpu.inc
IncludeLib   \masm32\fpulib\fpu.lib
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;Include	ComparisonMacros.inc
include     Macro.inc
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
calculateLinearRoot Proto :DWord,:DWord
InputR10            Proto :DWORD            ;Ptr Real10

.Data
Number0         Real10  0.0   ; used to determine if there are real roots in the
                              ; quadratic formula
Number2         Real10  2.0   ; number to use to get the denominator in the quadratic formula
Number1         Real10  1.0   ; number for comparison
Number4         Real10  4.0   ; number to get part of the square root number
Minus1          REAL10 -1.0
; 
NumberA         Real10  ?     ; the coefficient of X^2 in the quadratic equation
NumberB         Real10  ?     ; the coefficient of X in the quadratic equation
NumberC         Real10  ?     ; the constant in the quadratic equation
;------------------------------------
_RootX0         Real10 ?      ; first real root solution to the quadratic formula
_RootX1         Real10 ?      ; second real root solution to the quadratic formula
_LinearRootX    Real10 ?      ; real linear root solution to the linear equation
; ##############################################################################################

; 
.Code

start:
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    Call Main
    inkey          ; pause the screen while waiting for user to press any key
                   ; to continue
    exit
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<   Input10 procedure will convert input   <<
;<<   from keyboard into real10 numbers      <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

InputR10 Proc pR10:DWORD        ;Ptr Real10 the pointer to Real10 value is a DWORD value
    LOCAL r8:REAL8
    invoke crt_scanf, SADD("%lf"), ADDR r8
    mov eax, pR10
    finit
    fld r8
    fstp REAL10 PTR [eax]
    ret
InputR10 EndP
; ----------------------------------------------------------------------------------------------
Main Proc
  Local WantContinue:DWord
  ; WantContinue is a sentinel value for while loop

    Mov WantContinue, 0  ; set WantContinue = 0 to start while loop

    .While ((WantContinue >= 0) && (WantContinue < -1))
    ; while WantContinue greater than or equal to 0 And
    ; WantContinue less than -1
    
       print chr$(13, 10) ; a carriage return line feed will be outputted to the
                          ; screen
       print  chr$("Quadratic Equation : Ax^2 + Bx + C ", 13, 10, 13, 10)
       print  chr$("Enter a real number for A : ")
       Invoke InputR10, Addr NumberA
       print  chr$("Enter a real number for B : ")
       Invoke InputR10, Addr NumberB
       print  chr$("Enter a real number for C : ")
       Invoke InputR10, Addr NumberC

       Invoke  FpuComp, Addr NumberA, Offset Number0, SRC1_REAL Or SRC2_REAL
       Or      Eax, Eax
       Jz      ErrorInComp
       ; ------------------------------------
       ; If bit 0 of EAX=1 => NumberA=Number0
       ; ------------------------------------
       shr      al, 1                   ; mov bit 0 to Carry Flag
       jc       linear                  ; NumberA = 0
       ;
       Call    calculateQuadraticRoots   ; no parameters its the same
                                         ; invoke calculateQuadraticRoots

       print   chr$(13, 10)
       Jmp     ToContinue
;.........................................
ErrorInComp:
        print   chr$(13, 10)
        print   chr$(" Error comparing Number A against zero! ", 13, 10)
        jmp     ToContinue       
;..........................................
linear:
       Invoke FpuComp, Addr NumberB, Offset Number0, SRC1_REAL Or SRC2_REAL
       Or     Eax, Eax
       Jz     ZeroErrors
       ; ------------------------------------
       ; If bit 0 of EAX=1 => NumberB=Number0
       ; ------------------------------------
       shr      al, 1                   ; mov bit 0 to Carry Flag
       jc       ZeroErrors              ; NumberB = 0
       
        Invoke   calculateLinearRoot, Addr NumberB, Addr NumberC
        cmp      eax, 0
        jne      @F
        ;
        print   chr$(13, 10)
        print   chr$(" Error calculating linear roots", 13, 10)
        jmp     ToContinue

       ;
@@:    print chr$(13, 10)
       print chr$(" Solution to linear equation : ")
       print chr$(" ")
       print real10$ (NumberB)
       print chr$(" X ")
       print real10$ (NumberC)
       print chr$(" = 0 ", 13, 10, 13, 10)
       print chr$("X = ")
       print real10$ (_LinearRootX)
       Jmp ToContinue

ZeroErrors:
        print chr$(13, 10)
        print chr$(" Error, Numbers for A and B are zero! ", 13, 10)

ToContinue:
       Mov WantContinue, sval(input("Enter -1 to quit program : "))
       print chr$(13, 10)

    .EndW
  Ret
Main EndP
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<   printQuadraticFormat will output the quadratic equation entered by  <<
;<<   user to the screen                                                  <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

printQuadraticFormat Proc

    print chr$(" ")
    print real10$ (NumberA)
    print chr$(" X^2 + ")
    print real10$ (NumberB)
    print chr$(" X + ")
    print real10$ (NumberC)
    print chr$(" = 0 ", 13, 10)

   Ret
printQuadraticFormat EndP
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<  calculateLinearRoot procedure will calculate the root of the linear equation  <<
;<<  B x + C = 0  =>  x = - C / B
;<<  when NumberA is equal to 0 and NumberB is not equal to 0                      <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

calculateLinearRoot Proc  pNumB:DWord, pNumC:DWord
                    Local negativeNumC:Real10

     Lea    Edx, negativeNumC
     Invoke FpuChs, pNumC, Edx, SRC1_REAL                               ;Or SRC2_REAL
     cmp    eax, 0
     je     _rLinearRoot
     ;
     Invoke FpuDiv, Edx, pNumB, Offset _LinearRootX, SRC1_REAL Or SRC2_REAL
                    ; EAX= 0 -> error
_rLinearRoot:
	               Ret
calculateLinearRoot EndP
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<  calculateXRoots procedure will calculate the two real roots in the quadratic   <<
;<<  formula                                                                        <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
calculateXRoots Proc pNumA:DWord, pNumB:DWord, pNumC:DWord

                ; pNumA is a pointer to NumA
                ; pNumB is a pointer to NumB
                ; pNumC is a pointer to NumC

                Local NumB2:Real10
                Local Num4AC:Real10
                Local NumB2_4AC:Real10
                Local RootB2_4AC:Real10
                Local Num2A:Real10
                ; NumB2 = NumberB * NumberB
                ; Num4AC = 4 * NumberA * NumberC
                ; NumB2_4AC = (NumberB * NumberB) - (4 * NumberA * NumberC)
                ; RootB2_4AC = sqrt(NumB2_4AC)
                ; Num2A = 2 * NumberA = denominator

                Local SOLX0:Real10
                Local SOLX1:Real10
                ; SOLX0 = first solution to quadratic formula
                ; SOLX1 = second solution to quadratic formula

                lea     ebx, NumB2
                invoke  FpuMul, pNumB, pNumB, ebx, SRC1_REAL or SRC2_REAL
                or      eax, eax
                jz      _rRealRoots                                         ; error -> exit
                
                lea     ecx, Num4AC
                invoke  FpuMul, pNumA, pNumC, ecx, SRC1_REAL or SRC2_REAL
                or      eax, eax
                jz      _rRealRoots
                ;
                invoke  FpuMul, ecx, offset Number4, ecx, SRC1_REAL or SRC2_REAL
                or      eax, eax
                jz      _rRealRoots

                lea     edx, NumB2_4AC
                invoke  FpuSub, ebx, ecx, edx, SRC1_REAL or SRC2_REAL
                or      eax, eax
                jz      _rRealRoots
                ;
                ; Test if NumB2_4AC >= 0
                ; ----------------------
                invoke  FpuComp, edx, offset Number0, SRC1_REAL or SRC2_REAL
                or      eax, eax
                jz      _rRealRoots
                ;
                test    al, 00000100B
                jz      @F
                ;
                ; complex roots: NumB2_4AC < 0
                ; ----------------------------
                Mov Eax, 2
                clc
                ret
                ;
@@:             lea     ebx, RootB2_4AC
                invoke  FpuSqrt, edx, ebx, SRC1_REAL 
                or      eax, eax
                jz      _rRealRoots

                lea     ecx, SOLX0                                     
                invoke  FpuSub, ebx, pNumB, ecx, SRC1_REAL or SRC2_REAL
                or      eax, eax
                jz      _rRealRoots                                         

                lea     edx, SOLX1                                     
                invoke  FpuAdd, ebx, pNumB, edx, SRC1_REAL or SRC2_REAL
                or      eax, eax
                jz      _rRealRoots                                         

                lea     ebx, Num2A
                invoke  FpuMul, pNumA, offset Number2, ebx, SRC1_REAL or SRC2_REAL
                or      eax, eax
                jz      _rRealRoots                                         
                                
                ; SOLX0
                invoke  FpuDiv, ecx, ebx, offset _RootX0, SRC1_REAL or SRC2_REAL
                or      eax, eax
                jz      _rRealRoots                                         
                
                ; SOLX1
                invoke  FpuDiv, edx, ebx, edx, SRC1_REAL or SRC2_REAL 
                or      eax, eax
                jz      _rRealRoots                                         

                invoke  FpuMul, edx, offset Minus1, offset _RootX1, SRC1_REAL or SRC2_REAL 
                or      eax, eax
                jz      _rRealRoots                                         
                ; 
                mov     eax, 1               
                clc
                ret
                ;
                ; EAX = 0 => Error
                ;
_rRealRoots:    

                stc
                ret
calculateXRoots EndP
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<   calculateQuadraticRoots procedure will calculate two real roots    <<
;<<   of a quadratic equation by receiving three coefficients from       <<
;<<   user as input and display the answers                              <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

calculateQuadraticRoots Proc

     ; Quadratic Formula:  x = (-b +/- sqrt(b^2 - 4*a*c)) / (2*a)
     ; where a, b, and c are real numbers And  a != 0

      Invoke calculateXRoots, Addr NumberA, Addr NumberB, Addr NumberC
      Jc _ExitProc

      Cmp Eax, 2
      Je @F

      print chr$(13, 10)
      print chr$(" Solutions for quadratic equation : ", 13, 10)

      Invoke printQuadraticFormat

      print chr$(13, 10, 13, 10) ; two carriage return line feeds will be
                                 ; outputted to the screen
      print chr$(" X = ")
      print real10$ (_RootX0)   ; print the real number of one real root
                                ; in the quadratic formula
      print chr$(13, 10)
      print chr$("  1 ", 13, 10)
      print chr$(" X = ")
      print real10$ (_RootX1)   ; print the real number of another real root
                                ; in the quadratic formula
      print chr$(13, 10)
      print chr$("  2 ", 13, 10)
      print chr$(13, 10)

      Ret                       ; exit here
      ;Jmp _ExitProc

@@:
      print chr$(13, 10)
      print chr$("There are no real solutions for the quadratic equation : ", 13, 10)

      ; The following statement call output format procedure of the quadratic
      ; equation

      Invoke printQuadraticFormat

      print chr$(13, 10, "This equation has complex roots! ")
      print chr$(13, 10, 13, 10) ; ! will be outputted along with two
                                      ; carriage return line feeds to the screen
      Ret                       ; exit here                                      
;......................................................
_ExitProc:
        print chr$(13, 10)
        print chr$(" An Error occured while calculating the roots", 13, 10)
                        Ret
calculateQuadraticRoots EndP
; 
End     start
; ##############################################################################################
